evhttp(3) | Library Functions Manual | evhttp(3)

# NAME

evhttp - Basic support for HTTP serving.

# SYNOPSIS

#include <event2/http.h>
#include <event2/util.h>
#include <event2/visibility.h>

## Macros

#define EVHTTP_CON_LINGERING_CLOSE 0x0020
#define EVHTTP_CON_PUBLIC_FLAGS_END 0x100000
#define EVHTTP_CON_READ_ON_WRITE_ERROR 0x0010
#define EVHTTP_CON_REUSE_CONNECTED_ADDR 0x0008
#define EVHTTP_SERVER_LINGERING_CLOSE 0x0001
#define EVHTTP_URI_NONCONFORMANT 0x01
Tolerate URIs that do not conform to RFC3986. #define HTTP_BADMETHOD 405
method not allowed for this uri #define HTTP_BADREQUEST 400
invalid http request was made #define HTTP_ENTITYTOOLARGE 413
#define HTTP_EXPECTATIONFAILED 417
we can't handle this expectation #define HTTP_INTERNAL 500
internal error #define HTTP_MOVEPERM 301
the uri moved permanently #define HTTP_MOVETEMP 302
the uri moved temporarily #define HTTP_NOCONTENT 204
request does not have content #define HTTP_NOTFOUND 404
could not find content for uri #define HTTP_NOTIMPLEMENTED 501
not implemented #define HTTP_NOTMODIFIED 304
page was not modified from last #define HTTP_OK 200
request completed ok #define HTTP_SERVUNAVAIL 503
the server is not available

## Typedefs

typedef void evhttp_bound_socket_foreach_fn(struct evhttp_bound_socket *, void *)

## Enumerations

enum evhttp_cmd_type { EVHTTP_REQ_GET = 1 << 0, EVHTTP_REQ_POST = 1 << 1, EVHTTP_REQ_HEAD = 1 << 2, EVHTTP_REQ_PUT = 1 << 3, EVHTTP_REQ_DELETE = 1 << 4, EVHTTP_REQ_OPTIONS = 1 << 5, EVHTTP_REQ_TRACE = 1 << 6, EVHTTP_REQ_CONNECT = 1 << 7, EVHTTP_REQ_PATCH = 1 << 8 } The different request types supported by evhttp. "
enum evhttp_request_error { EVREQ_HTTP_TIMEOUT, EVREQ_HTTP_EOF, EVREQ_HTTP_INVALID_HEADER, EVREQ_HTTP_BUFFER_ERROR, EVREQ_HTTP_REQUEST_CANCEL, EVREQ_HTTP_DATA_TOO_LONG } The different error types supported by evhttp. "
enum evhttp_request_kind { EVHTTP_REQUEST, EVHTTP_RESPONSE } a request object can represent either a request or a reply "

## Functions

EVENT2_EXPORT_SYMBOL int evhttp_accept_socket (struct evhttp *http, evutil_socket_t fd)
Makes an HTTP server accept connections on the specified socket. EVENT2_EXPORT_SYMBOL struct evhttp_bound_socket * evhttp_accept_socket_with_handle (struct evhttp *http, evutil_socket_t fd)
Like evhttp_accept_socket(), but returns a handle for referencing the socket. EVENT2_EXPORT_SYMBOL int evhttp_add_header (struct evkeyvalq *headers, const char *key, const char *value)
Adds a header to a list of existing headers. EVENT2_EXPORT_SYMBOL int evhttp_add_server_alias (struct evhttp *http, const char *alias)
Add a server alias to an http object. EVENT2_EXPORT_SYMBOL int evhttp_add_virtual_host (struct evhttp *http, const char *pattern, struct evhttp *vhost)
Adds a virtual host to the http server. EVENT2_EXPORT_SYMBOL struct evhttp_bound_socket * evhttp_bind_listener (struct evhttp *http, struct evconnlistener *listener)
The most low-level evhttp_bind/accept method: takes an evconnlistener, and returns an evhttp_bound_socket. EVENT2_EXPORT_SYMBOL int evhttp_bind_socket (struct evhttp *http, const char *address, ev_uint16_t port)
Binds an HTTP server on the specified address and port. EVENT2_EXPORT_SYMBOL struct evhttp_bound_socket * evhttp_bind_socket_with_handle (struct evhttp *http, const char *address, ev_uint16_t port)
Like evhttp_bind_socket(), but returns a handle for referencing the socket. EVENT2_EXPORT_SYMBOL evutil_socket_t evhttp_bound_socket_get_fd (struct evhttp_bound_socket *bound_socket)
Get the raw file descriptor referenced by an evhttp_bound_socket. EVENT2_EXPORT_SYMBOL struct evconnlistener * evhttp_bound_socket_get_listener (struct evhttp_bound_socket *bound)
Return the listener used to implement a bound socket. EVENT2_EXPORT_SYMBOL void evhttp_cancel_request (struct evhttp_request *req)
Cancels a pending HTTP request. EVENT2_EXPORT_SYMBOL void evhttp_clear_headers (struct evkeyvalq *headers)
Removes all headers from the header list. EVENT2_EXPORT_SYMBOL struct evhttp_connection * evhttp_connection_base_bufferevent_new (struct event_base *base, struct evdns_base *dnsbase, struct bufferevent *bev, const char *address, ev_uint16_t port)
Create and return a connection object that can be used to for making HTTP requests. EVENT2_EXPORT_SYMBOL struct evhttp_connection * evhttp_connection_base_new (struct event_base *base, struct evdns_base *dnsbase, const char *address, ev_uint16_t port)
Create and return a connection object that can be used to for making HTTP requests. EVENT2_EXPORT_SYMBOL void evhttp_connection_free (struct evhttp_connection *evcon)
Frees an http connection. EVENT2_EXPORT_SYMBOL void evhttp_connection_free_on_completion (struct evhttp_connection *evcon)
Disowns a given connection object. EVENT2_EXPORT_SYMBOL const struct sockaddr * evhttp_connection_get_addr (struct evhttp_connection *evcon)
Get the remote address associated with this connection. EVENT2_EXPORT_SYMBOL struct event_base * evhttp_connection_get_base (struct evhttp_connection *req)
Returns the underlying event_base for this connection. EVENT2_EXPORT_SYMBOL struct bufferevent * evhttp_connection_get_bufferevent (struct evhttp_connection *evcon)
Return the bufferevent that an evhttp_connection is using. EVENT2_EXPORT_SYMBOL void evhttp_connection_get_peer (struct evhttp_connection *evcon, char **address, ev_uint16_t *port)
Get the remote address and port associated with this connection. EVENT2_EXPORT_SYMBOL struct evhttp * evhttp_connection_get_server (struct evhttp_connection *evcon)
Return the HTTP server associated with this connection, or NULL. EVENT2_EXPORT_SYMBOL void evhttp_connection_set_closecb (struct evhttp_connection *evcon, void(*)(struct evhttp_connection *, void *), void *)
Set a callback for connection close. EVENT2_EXPORT_SYMBOL void evhttp_connection_set_family (struct evhttp_connection *evcon, int family)
Set family hint for DNS requests. EVENT2_EXPORT_SYMBOL int evhttp_connection_set_flags (struct evhttp_connection *evcon, int flags)
Set connection flags. EVENT2_EXPORT_SYMBOL void evhttp_connection_set_initial_retry_tv (struct evhttp_connection *evcon, const struct timeval *tv)
Sets the delay before retrying requests on this connection. EVENT2_EXPORT_SYMBOL void evhttp_connection_set_local_address (struct evhttp_connection *evcon, const char *address)
sets the ip address from which http connections are made EVENT2_EXPORT_SYMBOL void evhttp_connection_set_local_port (struct evhttp_connection *evcon, ev_uint16_t port)
sets the local port from which http connections are made EVENT2_EXPORT_SYMBOL void evhttp_connection_set_max_body_size (struct evhttp_connection *evcon, ev_ssize_t new_max_body_size)
EVENT2_EXPORT_SYMBOL void evhttp_connection_set_max_headers_size (struct evhttp_connection *evcon, ev_ssize_t new_max_headers_size)
EVENT2_EXPORT_SYMBOL void evhttp_connection_set_retries (struct evhttp_connection *evcon, int retry_max)
Sets the retry limit for this connection - -1 repeats indefinitely. EVENT2_EXPORT_SYMBOL void evhttp_connection_set_timeout (struct evhttp_connection *evcon, int timeout_in_secs)
Sets the timeout in seconds for events related to this connection. EVENT2_EXPORT_SYMBOL void evhttp_connection_set_timeout_tv (struct evhttp_connection *evcon, const struct timeval *tv)
Sets the timeout for events related to this connection. EVENT2_EXPORT_SYMBOL char * evhttp_decode_uri (const char *uri)
Helper function to sort of decode a URI-encoded string. EVENT2_EXPORT_SYMBOL void evhttp_del_accept_socket (struct evhttp *http, struct evhttp_bound_socket *bound_socket)
Makes an HTTP server stop accepting connections on the specified socket. EVENT2_EXPORT_SYMBOL int evhttp_del_cb (struct evhttp *, const char *)
Removes the callback for a specified URI. EVENT2_EXPORT_SYMBOL char * evhttp_encode_uri (const char *str)
Helper function to encode a string for inclusion in a URI. EVENT2_EXPORT_SYMBOL const char * evhttp_find_header (const struct evkeyvalq *headers, const char *key)
Finds the value belonging to a header. EVENT2_EXPORT_SYMBOL void evhttp_foreach_bound_socket (struct evhttp *http, evhttp_bound_socket_foreach_fn *function, void *argument)
Applies the function specified in the first argument to all evhttp_bound_sockets associated with 'http'. EVENT2_EXPORT_SYMBOL void evhttp_free (struct evhttp *http)
Free the previously created HTTP server. EVENT2_EXPORT_SYMBOL char * evhttp_htmlescape (const char *html)
Escape HTML character entities in a string. EVENT2_EXPORT_SYMBOL int evhttp_make_request (struct evhttp_connection *evcon, struct evhttp_request *req, enum evhttp_cmd_type type, const char *uri)
Make an HTTP request over the specified connection. EVENT2_EXPORT_SYMBOL struct evhttp * evhttp_new (struct event_base *base)
Create a new HTTP server. EVENT2_EXPORT_SYMBOL int evhttp_parse_query (const char *uri, struct evkeyvalq *headers)
Helper function to parse out arguments in a query. EVENT2_EXPORT_SYMBOL int evhttp_parse_query_str (const char *uri, struct evkeyvalq *headers)
Helper function to parse out arguments from the query portion of an HTTP URI. EVENT2_EXPORT_SYMBOL int evhttp_remove_header (struct evkeyvalq *headers, const char *key)
Removes a header from a list of existing headers. EVENT2_EXPORT_SYMBOL int evhttp_remove_server_alias (struct evhttp *http, const char *alias)
Remove a server alias from an http object. EVENT2_EXPORT_SYMBOL int evhttp_remove_virtual_host (struct evhttp *http, struct evhttp *vhost)
Removes a virtual host from the http server. EVENT2_EXPORT_SYMBOL void evhttp_request_free (struct evhttp_request *req)
Frees the request object and removes associated events. EVENT2_EXPORT_SYMBOL enum evhttp_cmd_type evhttp_request_get_command (const struct evhttp_request *req)
Returns the request command. EVENT2_EXPORT_SYMBOL struct evhttp_connection * evhttp_request_get_connection (struct evhttp_request *req)
Returns the connection object associated with the request or NULL. EVENT2_EXPORT_SYMBOL const struct evhttp_uri * evhttp_request_get_evhttp_uri (const struct evhttp_request *req)
Returns the request URI (parsed) EVENT2_EXPORT_SYMBOL const char * evhttp_request_get_host (struct evhttp_request *req)
Returns the host associated with the request. EVENT2_EXPORT_SYMBOL struct evbuffer * evhttp_request_get_input_buffer (struct evhttp_request *req)
Returns the input buffer. EVENT2_EXPORT_SYMBOL struct evkeyvalq * evhttp_request_get_input_headers (struct evhttp_request *req)
Returns the input headers. EVENT2_EXPORT_SYMBOL struct evbuffer * evhttp_request_get_output_buffer (struct evhttp_request *req)
Returns the output buffer. EVENT2_EXPORT_SYMBOL struct evkeyvalq * evhttp_request_get_output_headers (struct evhttp_request *req)
Returns the output headers. EVENT2_EXPORT_SYMBOL int evhttp_request_get_response_code (const struct evhttp_request *req)
EVENT2_EXPORT_SYMBOL const char * evhttp_request_get_response_code_line (const struct evhttp_request *req)
EVENT2_EXPORT_SYMBOL const char * evhttp_request_get_uri (const struct evhttp_request *req)
Returns the request URI. EVENT2_EXPORT_SYMBOL int evhttp_request_is_owned (struct evhttp_request *req)
Returns 1 if the request is owned by the user. EVENT2_EXPORT_SYMBOL struct evhttp_request * evhttp_request_new (void(*cb)(struct evhttp_request *, void *), void *arg)
Creates a new request object that needs to be filled in with the request parameters. EVENT2_EXPORT_SYMBOL void evhttp_request_own (struct evhttp_request *req)
Takes ownership of the request object. EVENT2_EXPORT_SYMBOL void evhttp_request_set_chunked_cb (struct evhttp_request *, void(*cb)(struct evhttp_request *, void *))
Enable delivery of chunks to requestor. EVENT2_EXPORT_SYMBOL void evhttp_request_set_error_cb (struct evhttp_request *, void(*)(enum evhttp_request_error, void *))
Set a callback for errors. EVENT2_EXPORT_SYMBOL void evhttp_request_set_header_cb (struct evhttp_request *, int(*cb)(struct evhttp_request *, void *))
Register callback for additional parsing of request headers. EVENT2_EXPORT_SYMBOL void evhttp_request_set_on_complete_cb (struct evhttp_request *req, void(*cb)(struct evhttp_request *, void *), void *cb_arg)
Set a callback to be called on request completion of evhttp_send_* function. EVENT2_EXPORT_SYMBOL void evhttp_send_error (struct evhttp_request *req, int error, const char *reason)
Send an HTML error message to the client. EVENT2_EXPORT_SYMBOL void evhttp_send_reply (struct evhttp_request *req, int code, const char *reason, struct evbuffer *databuf)
Send an HTML reply to the client. EVENT2_EXPORT_SYMBOL void evhttp_send_reply_chunk (struct evhttp_request *req, struct evbuffer *databuf)
Send another data chunk as part of an ongoing chunked reply. EVENT2_EXPORT_SYMBOL void evhttp_send_reply_chunk_with_cb (struct evhttp_request *, struct evbuffer *, void(*cb)(struct evhttp_connection *, void *), void *arg)
Send another data chunk as part of an ongoing chunked reply. EVENT2_EXPORT_SYMBOL void evhttp_send_reply_end (struct evhttp_request *req)
Complete a chunked reply, freeing the request as appropriate. EVENT2_EXPORT_SYMBOL void evhttp_send_reply_start (struct evhttp_request *req, int code, const char *reason)
Initiate a reply that uses Transfer-Encoding chunked. EVENT2_EXPORT_SYMBOL void evhttp_set_allowed_methods (struct evhttp *http, ev_uint16_t methods)
Sets the what HTTP methods are supported in requests accepted by this server, and passed to user callbacks. EVENT2_EXPORT_SYMBOL void evhttp_set_bevcb (struct evhttp *http, struct bufferevent *(*cb)(struct event_base *, void *), void *arg)
Set a callback used to create new bufferevents for connections to a given evhttp object. EVENT2_EXPORT_SYMBOL int evhttp_set_cb (struct evhttp *http, const char *path, void(*cb)(struct evhttp_request *, void *), void *cb_arg)
Set a callback for a specified URI. EVENT2_EXPORT_SYMBOL void evhttp_set_default_content_type (struct evhttp *http, const char *content_type)
Set the value to use for the Content-Type header when none was provided. EVENT2_EXPORT_SYMBOL int evhttp_set_flags (struct evhttp *http, int flags)
Set connection flags for HTTP server. EVENT2_EXPORT_SYMBOL void evhttp_set_gencb (struct evhttp *http, void(*cb)(struct evhttp_request *, void *), void *arg)
Set a callback for all requests that are not caught by specific callbacks. EVENT2_EXPORT_SYMBOL void evhttp_set_max_body_size (struct evhttp *http, ev_ssize_t max_body_size)
XXX Document. EVENT2_EXPORT_SYMBOL void evhttp_set_max_headers_size (struct evhttp *http, ev_ssize_t max_headers_size)
XXX Document. EVENT2_EXPORT_SYMBOL void evhttp_set_timeout (struct evhttp *http, int timeout_in_secs)
Set the timeout for an HTTP request. EVENT2_EXPORT_SYMBOL void evhttp_set_timeout_tv (struct evhttp *http, const struct timeval *tv)
Set the timeout for an HTTP request. EVENT2_EXPORT_SYMBOL void evhttp_uri_free (struct evhttp_uri *uri)
Free all memory allocated for a parsed uri. EVENT2_EXPORT_SYMBOL const char * evhttp_uri_get_fragment (const struct evhttp_uri *uri)
Return the fragment part of an evhttp_uri (excluding the leading '#'), or NULL if it has no fragment set. EVENT2_EXPORT_SYMBOL const char * evhttp_uri_get_host (const struct evhttp_uri *uri)
Return the host part of an evhttp_uri, or NULL if it has no host set. EVENT2_EXPORT_SYMBOL const char * evhttp_uri_get_path (const struct evhttp_uri *uri)
Return the path part of an evhttp_uri, or NULL if it has no path set. EVENT2_EXPORT_SYMBOL int evhttp_uri_get_port (const struct evhttp_uri *uri)
Return the port part of an evhttp_uri, or -1 if there is no port set. EVENT2_EXPORT_SYMBOL const char * evhttp_uri_get_query (const struct evhttp_uri *uri)
Return the query part of an evhttp_uri (excluding the leading '?'), or NULL if it has no query set. EVENT2_EXPORT_SYMBOL const char * evhttp_uri_get_scheme (const struct evhttp_uri *uri)
Return the scheme of an evhttp_uri, or NULL if there is no scheme has been set and the evhttp_uri contains a Relative-Ref. EVENT2_EXPORT_SYMBOL const char * evhttp_uri_get_userinfo (const struct evhttp_uri *uri)
Return the userinfo part of an evhttp_uri, or NULL if it has no userinfo set. EVENT2_EXPORT_SYMBOL char * evhttp_uri_join (struct evhttp_uri *uri, char *buf, size_t limit)
Join together the uri parts from parsed data to form a URI-Reference. EVENT2_EXPORT_SYMBOL struct evhttp_uri * evhttp_uri_new (void)
Return a new empty evhttp_uri with no fields set. EVENT2_EXPORT_SYMBOL struct evhttp_uri * evhttp_uri_parse (const char *source_uri)
Alias for evhttp_uri_parse_with_flags(source_uri, 0) EVENT2_EXPORT_SYMBOL struct evhttp_uri * evhttp_uri_parse_with_flags (const char *source_uri, unsigned flags)
Helper function to parse a URI-Reference as specified by RFC3986. EVENT2_EXPORT_SYMBOL void evhttp_uri_set_flags (struct evhttp_uri *uri, unsigned flags)
Changes the flags set on a given URI. EVENT2_EXPORT_SYMBOL int evhttp_uri_set_fragment (struct evhttp_uri *uri, const char *fragment)
Set the fragment of an evhttp_uri, or clear the fragment if fragment==NULL. EVENT2_EXPORT_SYMBOL int evhttp_uri_set_host (struct evhttp_uri *uri, const char *host)
Set the host of an evhttp_uri, or clear the host if host==NULL. EVENT2_EXPORT_SYMBOL int evhttp_uri_set_path (struct evhttp_uri *uri, const char *path)
Set the path of an evhttp_uri, or clear the path if path==NULL. EVENT2_EXPORT_SYMBOL int evhttp_uri_set_port (struct evhttp_uri *uri, int port)
Set the port of an evhttp_uri, or clear the port if port==-1. EVENT2_EXPORT_SYMBOL int evhttp_uri_set_query (struct evhttp_uri *uri, const char *query)
Set the query of an evhttp_uri, or clear the query if query==NULL. EVENT2_EXPORT_SYMBOL int evhttp_uri_set_scheme (struct evhttp_uri *uri, const char *scheme)
Set the scheme of an evhttp_uri, or clear the scheme if scheme==NULL. EVENT2_EXPORT_SYMBOL int evhttp_uri_set_userinfo (struct evhttp_uri *uri, const char *userinfo)
Set the userinfo of an evhttp_uri, or clear the userinfo if userinfo==NULL. EVENT2_EXPORT_SYMBOL char * evhttp_uridecode (const char *uri, int decode_plus, size_t *size_out)
Helper function to decode a URI-escaped string or HTTP parameter. EVENT2_EXPORT_SYMBOL char * evhttp_uriencode (const char *str, ev_ssize_t size, int space_to_plus)
As evhttp_encode_uri, but if 'size' is nonnegative, treat the string as being 'size' bytes long.

# Detailed Description

Basic support for HTTP serving.
As Libevent is a library for dealing with event notification and most interesting applications are networked today, I have often found the need to write HTTP code. The following prototypes and definitions provide an application with a minimal interface for making HTTP requests and for creating a very simple HTTP server.

# Macro Definition Documentation

## #define EVHTTP_URI_NONCONFORMANT 0x01

Tolerate URIs that do not conform to RFC3986. Unfortunately, some HTTP clients generate URIs that, according to RFC3986, are not conformant URIs. If you need to support these URIs, you can do so by passing this flag to evhttp_uri_parse_with_flags.
Currently, these changes are:

•
  Nonconformant URIs are allowed to contain otherwise unreasonable characters in their path, query, and fragment components.

# Enumeration Type Documentation

## enum evhttp_cmd_type

The different request types supported by evhttp. These are as specified in RFC2616, except for PATCH which is specified by RFC5789.
By default, only some of these methods are accepted and passed to user callbacks; use evhttp_set_allowed_methods() to change which methods are allowed.

## enum evhttp_request_error

The different error types supported by evhttp.
See also:
evhttp_request_set_error_cb()
Enumerator

EVREQ_HTTP_TIMEOUT
  Timeout reached, also.

See also:
evhttp_connection_set_timeout()

EVREQ_HTTP_EOF
  EOF reached.

EVREQ_HTTP_INVALID_HEADER
  Error while reading header, or invalid header.

EVREQ_HTTP_BUFFER_ERROR
  Error encountered while reading or writing.

EVREQ_HTTP_REQUEST_CANCEL
  The evhttp_cancel_request() called on this request.

EVREQ_HTTP_DATA_TOO_LONG
  Body is greater then evhttp_connection_set_max_body_size()

# Function Documentation

## EVENT2_EXPORT_SYMBOL int evhttp_accept_socket (struct evhttp * http, evutil_socket_t fd)

Makes an HTTP server accept connections on the specified socket. This may be useful to create a socket and then fork multiple instances of an http server, or when a socket has been communicated via file descriptor passing in situations where an http servers does not have permissions to bind to a low-numbered port.
Can be called multiple times to have the http server listen to multiple different sockets.
Parameters:
http a pointer to an evhttp object
fd a socket fd that is ready for accepting connections
Returns:
0 on success, -1 on failure.
See also:
evhttp_bind_socket()

## EVENT2_EXPORT_SYMBOL struct evhttp_bound_socket* evhttp_accept_socket_with_handle (struct evhttp * http, evutil_socket_t fd)

Like evhttp_accept_socket(), but returns a handle for referencing the socket. The returned pointer is not valid after http is freed.
Parameters:
http a pointer to an evhttp object
fd a socket fd that is ready for accepting connections
Returns:
Handle for the socket on success, NULL on failure.
See also:
evhttp_accept_socket(), evhttp_del_accept_socket()

## EVENT2_EXPORT_SYMBOL int evhttp_add_header (struct evkeyvalq * headers, const char * key, const char * value)

Adds a header to a list of existing headers.
Parameters:
headers the evkeyvalq object to which to add a header
key the name of the header
value the value belonging to the header
Returns:
0 on success, -1 otherwise.
See also:
evhttp_find_header(), evhttp_clear_headers()

## EVENT2_EXPORT_SYMBOL int evhttp_add_server_alias (struct evhttp * http, const char * alias)

Add a server alias to an http object. The http object can be a virtual host or the main server.
Parameters:
http the evhttp object
alias the alias to add
See also:
evhttp_add_remove_alias()

## EVENT2_EXPORT_SYMBOL int evhttp_add_virtual_host (struct evhttp * http, const char * pattern, struct evhttp * vhost)

Adds a virtual host to the http server. A virtual host is a newly initialized evhttp object that has request callbacks set on it via evhttp_set_cb() or evhttp_set_gencb(). It most not have any listing sockets associated with it.
If the virtual host has not been removed by the time that evhttp_free() is called on the main http server, it will be automatically freed, too.
It is possible to have hierarchical vhosts. For example: A vhost with the pattern *.example.com may have other vhosts with patterns foo.example.com and bar.example.com associated with it.
Parameters:
http the evhttp object to which to add a virtual host
pattern the glob pattern against which the hostname is matched. The match is case insensitive and follows otherwise regular shell matching.
vhost the virtual host to add the regular http server.
Returns:
0 on success, -1 on failure
See also:
evhttp_remove_virtual_host()

## EVENT2_EXPORT_SYMBOL struct evhttp_bound_socket* evhttp_bind_listener (struct evhttp * http, struct evconnlistener * listener)

The most low-level evhttp_bind/accept method: takes an evconnlistener, and returns an evhttp_bound_socket. The listener will be freed when the bound socket is freed.

## EVENT2_EXPORT_SYMBOL int evhttp_bind_socket (struct evhttp * http, const char * address, ev_uint16_t port)

Binds an HTTP server on the specified address and port. Can be called multiple times to bind the same http server to multiple different ports.
Parameters:
http a pointer to an evhttp object
address a string containing the IP address to listen(2) on
port the port number to listen on
Returns:
0 on success, -1 on failure.
See also:
evhttp_accept_socket()

## EVENT2_EXPORT_SYMBOL struct evhttp_bound_socket* evhttp_bind_socket_with_handle (struct evhttp * http, const char * address, ev_uint16_t port)

Like evhttp_bind_socket(), but returns a handle for referencing the socket. The returned pointer is not valid after http is freed.
Parameters:
http a pointer to an evhttp object
address a string containing the IP address to listen(2) on
port the port number to listen on
Returns:
Handle for the socket on success, NULL on failure.
See also:
evhttp_bind_socket(), evhttp_del_accept_socket()

## EVENT2_EXPORT_SYMBOL evutil_socket_t evhttp_bound_socket_get_fd (struct evhttp_bound_socket * bound_socket)

Get the raw file descriptor referenced by an evhttp_bound_socket.
Parameters:
bound_socket a handle returned by evhttp_{bind,accept}_socket_with_handle
Returns:
the file descriptor used by the bound socket
See also:
evhttp_bind_socket_with_handle(), evhttp_accept_socket_with_handle()

## EVENT2_EXPORT_SYMBOL void evhttp_cancel_request (struct evhttp_request * req)

Cancels a pending HTTP request. Cancels an ongoing HTTP request. The callback associated with this request is not executed and the request object is freed. If the request is currently being processed, e.g. it is ongoing, the corresponding evhttp_connection object is going to get reset.
A request cannot be canceled if its callback has executed already. A request may be canceled reentrantly from its chunked callback.
Parameters:
req the evhttp_request to cancel; req becomes invalid after this call.

## EVENT2_EXPORT_SYMBOL void evhttp_clear_headers (struct evkeyvalq * headers)

Removes all headers from the header list.
Parameters:
headers the evkeyvalq object from which to remove all headers

## EVENT2_EXPORT_SYMBOL struct evhttp_connection* evhttp_connection_base_bufferevent_new (struct event_base * base, struct evdns_base * dnsbase, struct bufferevent * bev, const char * address, ev_uint16_t port)

Create and return a connection object that can be used to for making HTTP requests. The connection object tries to resolve address and establish the connection when it is given an http request object.
Parameters:
base the event_base to use for handling the connection
dnsbase the dns_base to use for resolving host names; if not specified host name resolution will block.
bev a bufferevent to use for connecting to the server; if NULL, a socket-based bufferevent will be created. This buffrevent will be freed when the connection closes. It must have no fd set on it.
address the address to which to connect
port the port to connect to
Returns:
an evhttp_connection object that can be used for making requests

## EVENT2_EXPORT_SYMBOL struct evhttp_connection* evhttp_connection_base_new (struct event_base * base, struct evdns_base * dnsbase, const char * address, ev_uint16_t port)

Create and return a connection object that can be used to for making HTTP requests. The connection object tries to resolve address and establish the connection when it is given an http request object.
Parameters:
base the event_base to use for handling the connection
dnsbase the dns_base to use for resolving host names; if not specified host name resolution will block.
address the address to which to connect
port the port to connect to
Returns:
an evhttp_connection object that can be used for making requests

## EVENT2_EXPORT_SYMBOL void evhttp_connection_free_on_completion (struct evhttp_connection * evcon)

Disowns a given connection object. Can be used to tell libevent to free the connection object after the last request has completed or failed.

## EVENT2_EXPORT_SYMBOL const struct sockaddr* evhttp_connection_get_addr (struct evhttp_connection * evcon)

Get the remote address associated with this connection. extracted from getpeername() OR from nameserver.
Returns:
NULL if getpeername() return non success, or connection is not connected, otherwise it return pointer to struct sockaddr_storage

## EVENT2_EXPORT_SYMBOL void evhttp_connection_get_peer (struct evhttp_connection * evcon, char ** address, ev_uint16_t * port)

Get the remote address and port associated with this connection.

## EVENT2_EXPORT_SYMBOL void evhttp_connection_set_closecb (struct evhttp_connection * evcon, void(*)(struct evhttp_connection *, void *), void *)

Set a callback for connection close.

## EVENT2_EXPORT_SYMBOL int evhttp_connection_set_flags (struct evhttp_connection * evcon, int flags)

Set connection flags.
See also:
EVHTTP_CON_*
Returns:
0 on success, otherwise non zero (for example if flag doesn't supported).

## EVENT2_EXPORT_SYMBOL void evhttp_connection_set_initial_retry_tv (struct evhttp_connection * evcon, const struct timeval * tv)

Sets the delay before retrying requests on this connection. This is only used if evhttp_connection_set_retries is used to make the number of retries at least one. Each retry after the first is twice as long as the one before it.

## EVENT2_EXPORT_SYMBOL void evhttp_connection_set_timeout_tv (struct evhttp_connection * evcon, const struct timeval * tv)

Sets the timeout for events related to this connection. Takes a struct timeval.

## EVENT2_EXPORT_SYMBOL char* evhttp_decode_uri (const char * uri)

Helper function to sort of decode a URI-encoded string. Unlike evhttp_get_decoded_uri, it decodes all plus characters that appear after the first question mark character, but no plusses that occur before. This is not a good way to decode URIs in whole or in part.
The returned string must be freed by the caller
Deprecated
This function is deprecated; you probably want to use evhttp_get_decoded_uri instead.
Parameters:
uri an encoded URI
Returns:
a newly allocated unencoded URI or NULL on failure

## EVENT2_EXPORT_SYMBOL void evhttp_del_accept_socket (struct evhttp * http, struct evhttp_bound_socket * bound_socket)

Makes an HTTP server stop accepting connections on the specified socket. This may be useful when a socket has been sent via file descriptor passing and is no longer needed by the current process.
If you created this bound socket with evhttp_bind_socket_with_handle or evhttp_accept_socket_with_handle, this function closes the fd you provided. If you created this bound socket with evhttp_bind_listener, this function frees the listener you provided.
bound_socket is an invalid pointer after this call returns.
Parameters:
http a pointer to an evhttp object
bound_socket a handle returned by evhttp_{bind,accept}_socket_with_handle
See also:
evhttp_bind_socket_with_handle(), evhttp_accept_socket_with_handle()

## EVENT2_EXPORT_SYMBOL char* evhttp_encode_uri (const char * str)

Helper function to encode a string for inclusion in a URI. All characters are replaced by their hex-escaped (%22) equivalents, except for characters explicitly unreserved by RFC3986 -- that is, ASCII alphanumeric characters, hyphen, dot, underscore, and tilde.
The returned string must be freed by the caller.
Parameters:
str an unencoded string
Returns:
a newly allocated URI-encoded string or NULL on failure

## EVENT2_EXPORT_SYMBOL const char* evhttp_find_header (const struct evkeyvalq * headers, const char * key)

Finds the value belonging to a header.
Parameters:
headers the evkeyvalq object in which to find the header
key the name of the header to find
Returns:
a pointer to the value for the header or NULL if the header could not be found.
See also:
evhttp_add_header(), evhttp_remove_header()

## EVENT2_EXPORT_SYMBOL void evhttp_foreach_bound_socket (struct evhttp * http, evhttp_bound_socket_foreach_fn * function, void * argument)

Applies the function specified in the first argument to all evhttp_bound_sockets associated with 'http'. The user must not attempt to free or remove any connections, sockets or listeners in the callback 'function'.
Parameters:
http pointer to an evhttp object
function function to apply to every bound socket
argument pointer value passed to function for every socket iterated

## EVENT2_EXPORT_SYMBOL void evhttp_free (struct evhttp * http)

Free the previously created HTTP server. Works only if no requests are currently being served.
Parameters:
http the evhttp server object to be freed
See also:
evhttp_start()

## EVENT2_EXPORT_SYMBOL char* evhttp_htmlescape (const char * html)

Escape HTML character entities in a string. Replaces <, >, ", ' and & with <, >, ", &#039; and & correspondingly.
The returned string needs to be freed by the caller.
Parameters:
html an unescaped HTML string
Returns:
an escaped HTML string or NULL on error

## EVENT2_EXPORT_SYMBOL int evhttp_make_request (struct evhttp_connection * evcon, struct evhttp_request * req, enum evhttp_cmd_type type, const char * uri)

Make an HTTP request over the specified connection. The connection gets ownership of the request. On failure, the request object is no longer valid as it has been freed.
Parameters:
evcon the evhttp_connection object over which to send the request
req the previously created and configured request object
type the request type EVHTTP_REQ_GET, EVHTTP_REQ_POST, etc.
uri the URI associated with the request
Returns:
0 on success, -1 on failure
See also:
evhttp_cancel_request()

## EVENT2_EXPORT_SYMBOL struct evhttp* evhttp_new (struct event_base * base)

Create a new HTTP server.
Parameters:
base (optional) the event base to receive the HTTP events
Returns:
a pointer to a newly initialized evhttp server structure
See also:
evhttp_free()

## EVENT2_EXPORT_SYMBOL int evhttp_parse_query (const char * uri, struct evkeyvalq * headers)

Helper function to parse out arguments in a query. Parsing a URI like
http://foo.com/?q=test&s=some+thing
will result in two entries in the key value queue.
The first entry is: key='q', value='test' The second entry is: key='s', value='some thing'
Deprecated
This function is deprecated as of Libevent 2.0.9. Use evhttp_uri_parse and evhttp_parse_query_str instead.
Parameters:
uri the request URI
headers the head of the evkeyval queue
Returns:
0 on success, -1 on failure

## EVENT2_EXPORT_SYMBOL int evhttp_parse_query_str (const char * uri, struct evkeyvalq * headers)

Helper function to parse out arguments from the query portion of an HTTP URI. Parsing a query string like
q=test&s=some+thing
will result in two entries in the key value queue.
The first entry is: key='q', value='test' The second entry is: key='s', value='some thing'
Parameters:
query_parse the query portion of the URI
headers the head of the evkeyval queue
Returns:
0 on success, -1 on failure

## EVENT2_EXPORT_SYMBOL int evhttp_remove_header (struct evkeyvalq * headers, const char * key)

Removes a header from a list of existing headers.
Parameters:
headers the evkeyvalq object from which to remove a header
key the name of the header to remove
Returns:
0 if the header was removed, -1 otherwise.
See also:
evhttp_find_header(), evhttp_add_header()

## EVENT2_EXPORT_SYMBOL int evhttp_remove_server_alias (struct evhttp * http, const char * alias)

Remove a server alias from an http object.
Parameters:
http the evhttp object
alias the alias to remove
See also:
evhttp_add_server_alias()

## EVENT2_EXPORT_SYMBOL int evhttp_remove_virtual_host (struct evhttp * http, struct evhttp * vhost)

Removes a virtual host from the http server.
Parameters:
http the evhttp object from which to remove the virtual host
vhost the virtual host to remove from the regular http server.
Returns:
0 on success, -1 on failure
See also:
evhttp_add_virtual_host()

## EVENT2_EXPORT_SYMBOL void evhttp_request_free (struct evhttp_request * req)

Frees the request object and removes associated events.

## EVENT2_EXPORT_SYMBOL struct evhttp_connection* evhttp_request_get_connection (struct evhttp_request * req)

Returns the connection object associated with the request or NULL. The user needs to either free the request explicitly or call evhttp_send_reply_end().

## EVENT2_EXPORT_SYMBOL const char* evhttp_request_get_host (struct evhttp_request * req)

Returns the host associated with the request. If a client sends an absolute URI, the host part of that is preferred. Otherwise, the input headers are searched for a Host: header. NULL is returned if no absolute URI or Host: header is provided.

## EVENT2_EXPORT_SYMBOL struct evhttp_request* evhttp_request_new (void(*)(struct evhttp_request *, void *) cb, void * arg)

Creates a new request object that needs to be filled in with the request parameters. The callback is executed when the request completed or an error occurred.

## EVENT2_EXPORT_SYMBOL void evhttp_request_own (struct evhttp_request * req)

Takes ownership of the request object. Can be used in a request callback to keep onto the request until evhttp_request_free() is explicitly called by the user.

## EVENT2_EXPORT_SYMBOL void evhttp_request_set_chunked_cb (struct evhttp_request *, void(*)(struct evhttp_request *, void *) cb)

Enable delivery of chunks to requestor.
Parameters:
cb will be called after every read of data with the same argument as the completion callback. Will never be called on an empty response. May drain the input buffer; it will be drained automatically on return.

## EVENT2_EXPORT_SYMBOL void evhttp_request_set_error_cb (struct evhttp_request *, void(*)(enum evhttp_request_error, void *))

Set a callback for errors.
See also:
evhttp_request_error for error types.
On error, both the error callback and the regular callback will be called, error callback is called before the regular callback.

## EVENT2_EXPORT_SYMBOL void evhttp_request_set_header_cb (struct evhttp_request *, int(*)(struct evhttp_request *, void *) cb)

Register callback for additional parsing of request headers.
Parameters:
cb will be called after receiving and parsing the full header. It allows analyzing the header and possibly closing the connection by returning a value < 0.

## EVENT2_EXPORT_SYMBOL void evhttp_request_set_on_complete_cb (struct evhttp_request * req, void(*)(struct evhttp_request *, void *) cb, void * cb_arg)

Set a callback to be called on request completion of evhttp_send_* function. The callback function will be called on the completion of the request after the output data has been written and before the evhttp_request object is destroyed. This can be useful for tracking resources associated with a request (ex: timing metrics).
Parameters:
req a request object
cb callback function that will be called on request completion
cb_arg an additional context argument for the callback

## EVENT2_EXPORT_SYMBOL void evhttp_send_error (struct evhttp_request * req, int error, const char * reason)

Send an HTML error message to the client.
Parameters:
req a request object
error the HTTP error code
reason a brief explanation of the error. If this is NULL, we'll just use the standard meaning of the error code.

## EVENT2_EXPORT_SYMBOL void evhttp_send_reply (struct evhttp_request * req, int code, const char * reason, struct evbuffer * databuf)

Send an HTML reply to the client. The body of the reply consists of the data in databuf. After calling evhttp_send_reply() databuf will be empty, but the buffer is still owned by the caller and needs to be deallocated by the caller if necessary.
Parameters:
req a request object
code the HTTP response code to send
reason a brief message to send with the response code
databuf the body of the response

## EVENT2_EXPORT_SYMBOL void evhttp_send_reply_chunk (struct evhttp_request * req, struct evbuffer * databuf)

Send another data chunk as part of an ongoing chunked reply. The reply chunk consists of the data in databuf. After calling evhttp_send_reply_chunk() databuf will be empty, but the buffer is still owned by the caller and needs to be deallocated by the caller if necessary.
Parameters:
req a request object
databuf the data chunk to send as part of the reply.

## EVENT2_EXPORT_SYMBOL void evhttp_send_reply_chunk_with_cb (struct evhttp_request *, struct evbuffer *, void(*)(struct evhttp_connection *, void *) cb, void * arg)

Send another data chunk as part of an ongoing chunked reply. The reply chunk consists of the data in databuf. After calling evhttp_send_reply_chunk() databuf will be empty, but the buffer is still owned by the caller and needs to be deallocated by the caller if necessary.
Parameters:
req a request object
databuf the data chunk to send as part of the reply.
cb callback funcion
call back's argument.

## EVENT2_EXPORT_SYMBOL void evhttp_send_reply_end (struct evhttp_request * req)

Complete a chunked reply, freeing the request as appropriate.
Parameters:
req a request object

## EVENT2_EXPORT_SYMBOL void evhttp_send_reply_start (struct evhttp_request * req, int code, const char * reason)

Initiate a reply that uses Transfer-Encoding chunked. This allows the caller to stream the reply back to the client and is useful when either not all of the reply data is immediately available or when sending very large replies.
The caller needs to supply data chunks with evhttp_send_reply_chunk() and complete the reply by calling evhttp_send_reply_end().
Parameters:
req a request object
code the HTTP response code to send
reason a brief message to send with the response code

## EVENT2_EXPORT_SYMBOL void evhttp_set_allowed_methods (struct evhttp * http, ev_uint16_t methods)

Sets the what HTTP methods are supported in requests accepted by this server, and passed to user callbacks. If not supported they will generate a '405 Method not allowed' response.
By default this includes the following methods: GET, POST, HEAD, PUT, DELETE
Parameters:
http the http server on which to set the methods
methods bit mask constructed from evhttp_cmd_type values

## EVENT2_EXPORT_SYMBOL void evhttp_set_bevcb (struct evhttp * http, struct bufferevent *(*)(struct event_base *, void *) cb, void * arg)

Set a callback used to create new bufferevents for connections to a given evhttp object. You can use this to override the default bufferevent type -- for example, to make this evhttp object use SSL bufferevents rather than unencrypted ones.
New bufferevents must be allocated with no fd set on them.
Parameters:
http the evhttp server object for which to set the callback
cb the callback to invoke for incoming connections
arg an context argument for the callback

## EVENT2_EXPORT_SYMBOL int evhttp_set_cb (struct evhttp * http, const char * path, void(*)(struct evhttp_request *, void *) cb, void * cb_arg)

Set a callback for a specified URI.
Parameters:
http the http sever on which to set the callback
path the path for which to invoke the callback
cb the callback function that gets invoked on requesting path
cb_arg an additional context argument for the callback
Returns:
0 on success, -1 if the callback existed already, -2 on failure

## EVENT2_EXPORT_SYMBOL void evhttp_set_default_content_type (struct evhttp * http, const char * content_type)

Set the value to use for the Content-Type header when none was provided. If the content type string is NULL, the Content-Type header will not be automatically added.
Parameters:
http the http server on which to set the default content type
content_type the value for the Content-Type header

## EVENT2_EXPORT_SYMBOL int evhttp_set_flags (struct evhttp * http, int flags)

Set connection flags for HTTP server.
See also:
EVHTTP_SERVER_*
Returns:
0 on success, otherwise non zero (for example if flag doesn't supported).

## EVENT2_EXPORT_SYMBOL void evhttp_set_gencb (struct evhttp * http, void(*)(struct evhttp_request *, void *) cb, void * arg)

Set a callback for all requests that are not caught by specific callbacks. Invokes the specified callback for all requests that do not match any of the previously specified request paths. This is catchall for requests not specifically configured with evhttp_set_cb().
Parameters:
http the evhttp server object for which to set the callback
cb the callback to invoke for any unmatched requests
arg an context argument for the callback

## EVENT2_EXPORT_SYMBOL void evhttp_set_max_body_size (struct evhttp * http, ev_ssize_t max_body_size)

XXX Document.

## EVENT2_EXPORT_SYMBOL void evhttp_set_max_headers_size (struct evhttp * http, ev_ssize_t max_headers_size)

XXX Document.

## EVENT2_EXPORT_SYMBOL void evhttp_set_timeout (struct evhttp * http, int timeout_in_secs)

Set the timeout for an HTTP request.
Parameters:
http an evhttp object
timeout_in_secs the timeout, in seconds

## EVENT2_EXPORT_SYMBOL void evhttp_set_timeout_tv (struct evhttp * http, const struct timeval * tv)

Set the timeout for an HTTP request.
Parameters:
http an evhttp object
tv the timeout, or NULL

## EVENT2_EXPORT_SYMBOL void evhttp_uri_free (struct evhttp_uri * uri)

Free all memory allocated for a parsed uri. Only use this for URIs generated by evhttp_uri_parse.
Parameters:
uri container with parsed data
See also:
evhttp_uri_parse()

## EVENT2_EXPORT_SYMBOL const char* evhttp_uri_get_host (const struct evhttp_uri * uri)

Return the host part of an evhttp_uri, or NULL if it has no host set. The host may either be a regular hostname (conforming to the RFC 3986 'regname' production), or an IPv4 address, or the empty string, or a bracketed IPv6 address, or a bracketed 'IP-Future' address.
Note that having a NULL host means that the URI has no authority section, but having an empty-string host means that the URI has an authority section with no host part. For example, 'mailto:user@example.com' has a host of NULL, but 'file:///etc/motd' has a host of ''.

## EVENT2_EXPORT_SYMBOL int evhttp_uri_get_port (const struct evhttp_uri * uri)

Return the port part of an evhttp_uri, or -1 if there is no port set.

## EVENT2_EXPORT_SYMBOL const char* evhttp_uri_get_scheme (const struct evhttp_uri * uri)

Return the scheme of an evhttp_uri, or NULL if there is no scheme has been set and the evhttp_uri contains a Relative-Ref.

## EVENT2_EXPORT_SYMBOL char* evhttp_uri_join (struct evhttp_uri * uri, char * buf, size_t limit)

Join together the uri parts from parsed data to form a URI-Reference. Note that no escaping of reserved characters is done on the members of the evhttp_uri, so the generated string might not be a valid URI unless the members of evhttp_uri are themselves valid.
Parameters:
uri container with parsed data
buf destination buffer
limit destination buffer size
Returns:
an joined uri as string or NULL on error
See also:
evhttp_uri_parse()

## EVENT2_EXPORT_SYMBOL struct evhttp_uri* evhttp_uri_parse_with_flags (const char * source_uri, unsigned flags)

Helper function to parse a URI-Reference as specified by RFC3986. This function matches the URI-Reference production from RFC3986, which includes both URIs like
scheme://[[userinfo]@]foo.com[:port]]/[path][?query][#fragment]
and relative-refs like
[path][?query][#fragment]
Any optional elements portions not present in the original URI are left set to NULL in the resulting evhttp_uri. If no port is specified, the port is set to -1.
Note that no decoding is performed on percent-escaped characters in the string; if you want to parse them, use evhttp_uridecode or evhttp_parse_query_str as appropriate.
Note also that most URI schemes will have additional constraints that this function does not know about, and cannot check. For example, mailto://www.example.com/cgi-bin/fortune.pl is not a reasonable mailto url, http://www.example.com:99999/ is not a reasonable HTTP URL, and ftp:username@example.com is not a reasonable FTP URL. Nevertheless, all of these URLs conform to RFC3986, and this function accepts all of them as valid.
Parameters:
source_uri the request URI
flags Zero or more EVHTTP_URI_* flags to affect the behavior of the parser.
Returns:
uri container to hold parsed data, or NULL if there is error
See also:
evhttp_uri_free()

## EVENT2_EXPORT_SYMBOL void evhttp_uri_set_flags (struct evhttp_uri * uri, unsigned flags)

Changes the flags set on a given URI. See EVHTTP_URI_* for a list of flags.

## EVENT2_EXPORT_SYMBOL int evhttp_uri_set_fragment (struct evhttp_uri * uri, const char * fragment)

Set the fragment of an evhttp_uri, or clear the fragment if fragment==NULL. The fragment should not include a leading '#'. Returns 0 on success, -1 if fragment is not well-formed.

## EVENT2_EXPORT_SYMBOL int evhttp_uri_set_host (struct evhttp_uri * uri, const char * host)

Set the host of an evhttp_uri, or clear the host if host==NULL. Returns 0 on success, -1 if host is not well-formed.

## EVENT2_EXPORT_SYMBOL int evhttp_uri_set_path (struct evhttp_uri * uri, const char * path)

Set the path of an evhttp_uri, or clear the path if path==NULL. Returns 0 on success, -1 if path is not well-formed.

## EVENT2_EXPORT_SYMBOL int evhttp_uri_set_port (struct evhttp_uri * uri, int port)

Set the port of an evhttp_uri, or clear the port if port==-1. Returns 0 on success, -1 if port is not well-formed.

## EVENT2_EXPORT_SYMBOL int evhttp_uri_set_query (struct evhttp_uri * uri, const char * query)

Set the query of an evhttp_uri, or clear the query if query==NULL. The query should not include a leading '?'. Returns 0 on success, -1 if query is not well-formed.

## EVENT2_EXPORT_SYMBOL int evhttp_uri_set_scheme (struct evhttp_uri * uri, const char * scheme)

Set the scheme of an evhttp_uri, or clear the scheme if scheme==NULL. Returns 0 on success, -1 if scheme is not well-formed.

## EVENT2_EXPORT_SYMBOL int evhttp_uri_set_userinfo (struct evhttp_uri * uri, const char * userinfo)

Set the userinfo of an evhttp_uri, or clear the userinfo if userinfo==NULL. Returns 0 on success, -1 if userinfo is not well-formed.

## EVENT2_EXPORT_SYMBOL char* evhttp_uridecode (const char * uri, int decode_plus, size_t * size_out)

Helper function to decode a URI-escaped string or HTTP parameter. If 'decode_plus' is 1, then we decode the string as an HTTP parameter value, and convert all plus ('+') characters to spaces. If 'decode_plus' is 0, we leave all plus characters unchanged.
The returned string must be freed by the caller.
Parameters:
uri a URI-encode encoded URI
decode_plus determines whether we convert '+' to space.
size_out if size_out is not NULL, *size_out is set to the size of the returned string
Returns:
a newly allocated unencoded URI or NULL on failure

## EVENT2_EXPORT_SYMBOL char* evhttp_uriencode (const char * str, ev_ssize_t size, int space_to_plus)

As evhttp_encode_uri, but if 'size' is nonnegative, treat the string as being 'size' bytes long. This allows you to encode strings that may contain 0-valued bytes.
The returned string must be freed by the caller.
Parameters:
str an unencoded string
size the length of the string to encode, or -1 if the string is NUL-terminated
space_to_plus if true, space characters in 'str' are encoded as +, not %20.
Returns:
a newly allocate URI-encoded string, or NULL on failure.

# Author

Generated automatically by Doxygen for libevent from the source code.

Tue Jan 31 2017 | libevent